"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flushBeforeNextRenderCallbacks = flushBeforeNextRenderCallbacks;
exports.setPerformWork = setPerformWork;
exports.scheduleBeforeNextRenderCallback = void 0;
var performWork = null;

var setImmediatePolyfill = function setImmediatePolyfill(job) {
  return setTimeout(job, 0);
}; // 0s


var scheduleImmediateCallback = typeof setImmediate === 'undefined' ? setImmediatePolyfill : setImmediate;
var cancelImmediateCallback = typeof clearImmediate === 'undefined' ? clearTimeout : clearImmediate;
var beforeNextRenderCallbacks = [];
var beforeNextRenderCallbackId;

var scheduleBeforeNextRenderCallback = function scheduleBeforeNextRenderCallback(callback) {
  if (beforeNextRenderCallbacks.length === 0) {
    beforeNextRenderCallbackId = scheduleImmediateCallback(commitBeforeNextRenderCallbacks);
  }

  beforeNextRenderCallbacks.push(callback);
};

exports.scheduleBeforeNextRenderCallback = scheduleBeforeNextRenderCallback;

function commitBeforeNextRenderCallbacks() {
  var preCallbacks = beforeNextRenderCallbacks;
  beforeNextRenderCallbacks = [];
  preCallbacks.forEach(function (callback) {
    return callback();
  });
  preCallbacks = null; // exec callback maybe schedule a work

  performWork();
}

function flushBeforeNextRenderCallbacks() {
  if (beforeNextRenderCallbacks.length !== 0) {
    cancelImmediateCallback(beforeNextRenderCallbackId);
    commitBeforeNextRenderCallbacks();
  }
}

function setPerformWork(handle) {
  performWork = handle;
}